# The building of maven-shade-plugin and jdependency
# depend on each other. When building maven-shade-plugin
# for bootstrap, we use jdependency.jar from maven central
# repository.
%bcond_with bootstrap

%global jdependency_version 2.8.0

Summary:        Apache Maven Shade Plugin
Name:           maven-shade-plugin
Version:        3.4.1
Release:        4%{?dist}
License:        ASL 2.0
URL:            https://maven.apache.org/plugins/%{name}
Source0:        https://repo1.maven.org/maven2/org/apache/maven/plugins/%{name}/%{version}/%{name}-%{version}-source-release.zip
Source1:        https://repo1.maven.org/maven2/org/vafer/jdependency/%{jdependency_version}/jdependency-%{jdependency_version}.jar
Source2:        https://repo1.maven.org/maven2/org/vafer/jdependency/%{jdependency_version}/jdependency-%{jdependency_version}.pom

BuildRequires:  maven-local mvn(commons-io:commons-io) mvn(junit:junit)
BuildRequires:  mvn(org.apache.commons:commons-lang3)
BuildRequires:  mvn(org.apache.maven:maven-artifact)
BuildRequires:  mvn(org.apache.maven:maven-core)
BuildRequires:  mvn(org.apache.maven:maven-model)
BuildRequires:  mvn(org.apache.maven:maven-plugin-api)
BuildRequires:  mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-plugins:pom:)
BuildRequires:  mvn(org.apache.maven.plugin-tools:maven-plugin-annotations)
BuildRequires:  mvn(org.apache.maven.shared:maven-artifact-transfer)
BuildRequires:  mvn(org.apache.maven.shared:maven-dependency-tree)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-annotations)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-metadata)
BuildRequires:  mvn(org.codehaus.plexus:plexus-utils)
BuildRequires:  mvn(org.jdom:jdom2) mvn(org.mockito:mockito-all)
BuildRequires:  mvn(org.ow2.asm:asm)  mvn(org.ow2.asm:asm-commons)
BuildRequires:  mvn(xmlunit:xmlunit)
BuildRequires:  mvn(org.slf4j:slf4j-api) mvn(javax.inject:javax.inject)
BuildRequires:  mvn(org.apache.commons:commons-collections4)
BuildRequires:  mvn(org.eclipse.sisu:sisu-maven-plugin)
BuildRequires:  mvn(org.sonatype.sisu:sisu-guice::no_aop:)
BuildRequires:  mvn(org.eclipse.sisu:org.eclipse.sisu.plexus)
%if %{without bootstrap}
BuildRequires:  mvn(org.vafer:jdependency)
%endif
BuildArch:      noarch

%if %{with bootstrap}
Requires:       javapackages-filesystem
Requires:       mvn(commons-io:commons-io)
Requires:       mvn(org.apache.commons:commons-collections4)
Requires:       mvn(org.apache.maven.shared:maven-artifact-transfer)
Requires:       mvn(org.apache.maven.shared:maven-dependency-tree)
Requires:       mvn(org.codehaus.plexus:plexus-utils)
Requires:       mvn(org.jdom:jdom2)
Requires:       mvn(org.ow2.asm:asm)
Requires:       mvn(org.ow2.asm:asm-commons)
Requires:       mvn(org.slf4j:slf4j-api)
AutoReq:		no
%endif

%description
This plugin provides the capability to package the artifact in an uber-jar, 
including its dependencies and to shade - i.e. rename - the packages of 
some of the dependencies.

%javadoc_package

%prep
%autosetup

rm src/test/jars/plexus-utils-1.4.1.jar
ln -s $(build-classpath plexus/utils) src/test/jars/plexus-utils-1.4.1.jar

%pom_remove_dep 'org.eclipse.sisu:org.eclipse.sisu.inject:'

%if %{with bootstrap}
rm -rf ${HOME}/.m2
mkdir -p ${HOME}/.m2/repository/org/vafer/jdependency/%{jdependency_version}
cp %{SOURCE1} %{SOURCE2} ${HOME}/.m2/repository/org/vafer/jdependency/%{jdependency_version}
%endif

%build
%mvn_build
%pom_remove_dep 'org.vafer:jdependency'

%if %{with bootstrap}
rm -rf ${HOME}/.m2/
%endif

%install
%mvn_install

%files -f .mfiles
%license LICENSE NOTICE

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 26 2023 Xiaojie Chen <jackxjchen@tencent.com> - 3.4.1-2
- Disable bootstrap

* Tue Apr 25 2023 Xiaojie Chen <jackxjchen@tencent.com> - 3.4.1-1
- Initial build
